﻿using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;

namespace TestProject
{
    /// <summary>
    /// 다각선
    /// </summary>
    public class Polyline
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// 색상
        /// </summary>
        [XmlIgnore]
        public Color Color = Color.Black;

        /// <summary>
        /// 두께
        /// </summary>
        public int Thickness = 1;

        /// <summary>
        /// 대시 스타일
        /// </summary>
        public DashStyle DashStyle = DashStyle.Solid;

        /// <summary>
        /// 포인트 리스트
        /// </summary>
        public List<Point> PointList = new List<Point>();

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ARGB - ARGB

        /// <summary>
        /// ARGB
        /// </summary>
        public int ARGB
        {
            get
            {
                return Color.ToArgb();
            }
            set
            {
                Color = Color.FromArgb(value);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 그리기 - Draw(graphics)

        /// <summary>
        /// 그리기
        /// </summary>
        /// <param name="graphics">그래픽스</param>
        public void Draw(Graphics graphics)
        {
            using(Pen pen = new Pen(Color, Thickness))
            {
                pen.DashStyle = DashStyle;

                if(DashStyle == DashStyle.Custom)
                {
                    pen.DashPattern = new float[] { 10, 2 };
                }

                graphics.DrawLines(pen, PointList.ToArray());
            }
        }

        #endregion
    }
}